angular.module('starter.controllers', [])

.controller('HomeCtrl', function($scope, $ionicModal) {

  $ionicModal.fromTemplateUrl('templates/authors.html', {
    scope: $scope,
    animation: 'slide-in-up'
  }).then(function(modal) {
    $scope.authorsModal = modal;
  });

  $ionicModal.fromTemplateUrl('templates/rules.html', {
    scope: $scope,
    animation: 'slide-in-up'
  }).then(function(modal) {
    $scope.rulesModal = modal;
  });

  $ionicModal.fromTemplateUrl('templates/submit.html', {
    scope: $scope,
    animation: 'slide-in-up'
  }).then(function(modal) {
    $scope.submitModal = modal;
  });

  $scope.openAuthorsModal = function() {
    $scope.authorsModal.show();
  };
  $scope.closeAuthorsModal = function() {
    $scope.authorsModal.hide();
  };

  $scope.openRulesModal = function() {
    $scope.rulesModal.show();
  };
  $scope.closeRulesModal = function() {
    $scope.rulesModal.hide();
  };

  $scope.openSubmitModal = function() {
    $scope.submitModal.show();
  };
  $scope.closeSubmitModal = function() {
    $scope.submitModal.hide();
  };
})

.controller('GameWordsCtrl', function($scope, $http, $window, $ionicModal) {
  $scope.words = [];
  $scope.currentWord = "Kraunamatas..."

  $scope.currentWordEl = $('.current-word');
  $scope.pastWordEl = $('.past-word');

  $http.get('data/words.json')
  .then(function (res) {
    $scope.words = res.data.words;
    $scope.words = _.shuffle($scope.words);
    $scope.resetWordPositions();
    $scope.nextWord();
  });

  $ionicModal.fromTemplateUrl('templates/rules.html', {
    scope: $scope,
    animation: 'slide-in-up'
  }).then(function(modal) {
    $scope.rulesModal = modal;
  });

  $scope.resetWordPositions = function() {
    $scope.currentWordEl.addClass('pushed');
    $scope.pastWordEl.addClass('pushed');
  }

  $scope.nextWord = function() {

    $scope.pastWord = $scope.currentWord;
    $scope.currentWord = $scope.words.pop();

    $scope.resetWordPositions();
    window.setTimeout(function() {
      $scope.currentWordEl.removeClass('pushed');
      $scope.pastWordEl.removeClass('pushed');
    }, 20);
  }

  $scope.closeGame = function() {
    $window.history.back();
  }

  $scope.openRulesModal = function() {
    $scope.rulesModal.show();
  };
  $scope.closeRulesModal = function() {
    $scope.rulesModal.hide();
  };
})

.controller('SubmitCtrl', function($scope, $ionicModal, $http) {
  $scope.wordForm = {};
  $scope.wordForm.word = "";
  $scope.wordForm.disabled = false;

  $scope.wordForm.submitForm = function(item, event) {
    $scope.wordForm.disabled = true;
    var dataObject = { word: $scope.wordForm.word };
    var responsePromise = $http.post("http://enigmatic-anchorage-8115.herokuapp.com/words/", dataObject);
    responsePromise.success(function(data, status, headers, config) { 
      navigator.notification.alert("Žodis gautas!", function() {}, "Ačiū", "Valio!");
    });
    responsePromise.error(function(data, status, headers, config) {
      navigator.notification.alert("Kažkas nepavyko. Gal žodis per keistas?", function() {
        $scope.wordForm.disabled = false; $scope.wordForm.word = "";
      }, "Nepavyko", "O ne!");
      $scope.wordForm.disabled = false; $scope.wordForm.word = "";
    });
    responsePromise.then(function() { $scope.wordForm.disabled = false; $scope.wordForm.word = ""; });
  };
})


.controller('StaticCtrl', function($scope, $ionicModal) {});


// - word animation
// - office and socks
